//~--- JDK imports ------------------------------------------------------------

import java.io.*;

import java.net.*;
import javax.net.*;
import javax.net.ssl.*;

import javax.swing.*;
import java.awt.*;

public class Net extends SwingWorker<Integer, Void> {
	int protocol_state = 0; // init,5 is highest
	// aux method
	// if n == 0, always returns true
	private static boolean equalsCharArray(char[] a, char[] b, int n) {
		while (--n > 0) {
			if (a[n] != b[n])
				return false;
		}

		return true;
	}

	String expectingExecToolResp = null;// set to toolName or null
	boolean expectingUpdateResp = false;// set to toolName or null
	InputStreamReader isr = null;

	Jkmt jkmt = Jkmt.getInstance();

	// java 6 swingbuilder
	Socket socket = null;

	static JOptionPane paneTf = null;//tool LOOP failures
	static JOptionPane paneAlert = null;
	static int countTf= 0;
	static int countAlert= 0;

	// only intended for use in the processToolFailure() and processAlert()
	//
	// toolFailureOrAlert false=TF,true=ALERT
	private void _processToolFailureOrAlert(InputStreamReader isr,
			boolean toolFailureOrAlert) {
		int n, rr;
		char c, cn;
		String toolName = "";
		String n_str = "";
		String singleOrLoopStr = ""; /* only used for toolFailureOrAlert= true */

		try {
			for (;;) {
				cn = (char) isr.read();
				if (cn == ' ')
					break;
				toolName += cn;
			}

			if (toolFailureOrAlert == false)
				for (;;) {
					cn = (char) isr.read();
					if (cn == ' ')
						break;
					singleOrLoopStr += cn;
				}

	/* no need to ensure toolName.equals(this.expectingExecToolResp),as it can only have one exec_tool at a time */
		if("SINGLE".equals(singleOrLoopStr))
		{
			this.expectingExecToolResp = null;
/* remove hourglass cursor */
								jkmt
										.setCursor(new Cursor(
														Cursor.DEFAULT_CURSOR));
		}

	

			for (;;) {
				cn = (char) isr.read();

				if ((cn >= '0') && (cn <= '9')) {
					n_str += cn;

					continue; // top of this for loop
				}

				if (cn != ' ') {
					// error
				}

				n = Integer.parseInt(n_str);

				System.out.println("n = " + n);

				char[] bufc = new char[n];

				// blocked read of n
				rr = isr.read(bufc, 0, n);
				System.out.println("!rr = " + rr);

				if (rr == -1) {
					// end of stream reached. Not an IOException
				}

				// TODO check n == rr
				char nl = (char) isr.read(); // the final \n ending it

				// if nl == -1
				if (nl == '\n') {

					jkmt.consolePanels.println(toolName, Color.BLACK,
							(toolFailureOrAlert ? "ALERT" : singleOrLoopStr + " TOOL FAILURE")
									+ ": " + toolName + ":");

		Color co;
		JOptionPane pane;
		if(toolFailureOrAlert)
		{
			co = Color.RED; //Alert
			pane = Net.paneAlert;
		}
		else /* ToolFailure */
		{
		if("SINGLE".equals(singleOrLoopStr))
		    co = Color.GREEN; // same as the +OK for exec_tool
		else co = Color.MAGENTA;

		pane = Net.paneTf;
		}
					jkmt.consolePanels.println(toolName, co, new String(bufc));

					
					    Object val = null;
					    if(pane != null)
						val = pane.getValue();

					// if val is null the user has closed the window w/o making choice
						if(val == null) 
						{
						 						String[] stra = ((toolFailureOrAlert ? "ALERT: " : "TOOL FAILURE: ") + toolName + "\n\n\n\n\n\n" + new String(
								bufc)).split("\n"); /* tokenize by line */
						String htmlMsg = ToolTab.strHtmlBuild(stra);
						// JOptionPane.showMessageDialog(jkmt, htmlMsg);
						// instead create non-modal messagedialog
						JDialog dialog;

						if(toolFailureOrAlert)
						{
						Net.paneAlert = new JOptionPane(htmlMsg);
						Net.paneAlert.setMessageType(JOptionPane.WARNING_MESSAGE);
dialog = Net.paneAlert.createDialog(jkmt, "ALERT");
						} else {

						Net.paneTf = new JOptionPane(htmlMsg);
						Net.paneTf.setMessageType(JOptionPane.ERROR_MESSAGE);

dialog = Net.paneTf.createDialog(jkmt, "TOOL FAILURE");
					 }	
						dialog.setModal(false);
						dialog.show();

						if(toolFailureOrAlert)
						countAlert = 1;
						else countTf = 1;
						} else if(val == JOptionPane.UNINITIALIZED_VALUE)
						{
						/* exists, and user has not yet made a choice */
						/* perhaps they minimized, perhaps its in foreground, it's modal so they can still work with rest of the app. */
						/* update the gui text to the new error */

					String[] stra;
					
					
			if(toolFailureOrAlert)
			 stra = ("ALERT: " + toolName + "\n"  + (++countAlert > 0 ? countAlert + " ALERT pop-ups have been ignored. View console to see the previous.\nThe following is the latest received: \n\n" : "") + new String(bufc)).split("\n");
			 else 
			     stra = ("TOOL FAILURE: " + toolName + "\n"  + (++countTf > 0 ? countTf + " TOOL FAILURE pop-ups have been ignored. View console to see the previous.\nThe following is the latest received: \n\n" : "") + new String(
								bufc)).split("\n"); /* tokenize by line */
						String htmlMsg = ToolTab.strHtmlBuild(stra);
						if(toolFailureOrAlert)
						paneAlert.setMessage(htmlMsg);
						else paneTf.setMessage(htmlMsg);
						}
						else {
						    /* exists, and user has made some choice. will be going away very soon if it even gets here */
			if(toolFailureOrAlert)
			{
				Net.paneAlert = null;/* safe to popup more */
				Net.countAlert=0;
			}
				else
				 {
				    Net.paneTf = null;/* safe to popup more */
			        	Net.countTf = 0;
						}

						}




					/* OLD ALERT CODE todo the popup. */
					{

					//	if (jkmt.alertsWin == null) /* first time */
					/*
							jkmt.alertsWin = new AlertsWin();

						jkmt.alertsWin.consolePanel.println(Color.BLACK,
								"ALERT: " + toolName + ":");
						jkmt.alertsWin.consolePanel.println(Color.RED,
								new String(bufc));

						jkmt.alertsWin.setVisible(true);
						*/
					}

					// success
				} else
					System.out.println("expected '\\n': got " + nl);

				break;
			}
		} catch (java.net.SocketException se) {
			JOptionPane.showMessageDialog(jkmt, "Connection reset by peer");
			// return false;
		} catch (IOException ioe) {
			ioe.printStackTrace();
		}
	}

	@Override
	public Integer doInBackground() {
		String host = jkmt.serverTab.hostField.getText();
		int port = Integer.parseInt(jkmt.serverTab.portField.getText());
		String passwd = jkmt.serverTab.passwdField.getText();

		try {
			if (jkmt.serverTab.sslCheckBox.isSelected()) {
				//SocketFactory socketFactory = SSLSocketFactory.getDefault();
				SocketFactory socketFactory = BlindSSLSocketFactoryTest.getDefault();
				this.socket = socketFactory.createSocket(host, port);
			} else {
				this.socket = new Socket(host, port);
			}

			OutputStream os = socket.getOutputStream();
			isr = new InputStreamReader(socket.getInputStream());
			jkmt.consolePanels
					.printlnJkmt("Connected to server.\nAuthenticating...");
			jkmt.serverTab.cbutton.setText("Disconnect");
			jkmt.serverTab.cbutton.setActionCommand("disconnect"); // switch
			// action
			// command


						char[] buffer = new char[15];
						boolean notExpected = false;


			for (;;) {
				Thread.sleep(50);

				// returns true if data available, read would have blocked
				// otherwise.
				// mayb eget rid of this isr.ready() and sleep thing, and just
				// let it block..

				/* if (isr.ready()) */

				//	jkmt.consolePanel.println("state = " + protocol_state);
					switch (protocol_state) {
					case 0:
						byte[] authline = ("AUTH " + passwd + '\n').getBytes();
						os.write(authline);

						protocol_state = 1;
						break;
					// expecting server to send update conf
					case 1: // enum later,init
						char[] cmd = new char["UPDATE_CONF".length()];

						// blocked read of n
						int rr = isr.read(cmd, 0, "UPDATE_CONF".length());

						// if(rr == -1//
						// if(rr != that length
						// System.out.println("cmd = " + new String(cmd));

						if (!"UPDATE_CONF".equals(new String(cmd))) {
							System.out.println("didnt receive update_conf");
							// TODO: parse if it was a -ERR from auth and pop it
							// up
						
						jkmt.consolePanels.printlnJkmt("Authenticated Failed");
							JOptionPane
									.showMessageDialog(jkmt,
											"Error: Could not authenticate with server");
							throw new InterruptedException(); // using like a
							// goto here.
						}

						jkmt.consolePanels.printlnJkmt("Authenticated Successfully");

						char c = (char) isr.read();

						// System.out.println("c = *"+c+"*");
						// if(rr == -1)
						if (c != ' ') // UPDATE_CONF 933 <msg>\n
						{
							// error
						}
						int n;
						String n_str = "";

						for (;;) {
							char cn = (char) isr.read();

							if ((cn >= '0') && (cn <= '9')) {
								n_str += cn;

								continue; // top of this for loop
							}

							if (cn == ' ') {
								n = Integer.parseInt(n_str);

								System.out.println("n = " + n);

								char[] buf = new char[n];

								// blocked read of n
								rr = isr.read(buf, 0, n);
								System.out.println("rr = " + rr);

								if (rr == -1) {

									// end of stream reached. Not an IOException
								}

								// TODO check n == rr
								char nl = (char) isr.read(); // the final \n
								// ending it

								// if nl == -1
								if (nl == '\n') {

									// success, load buf into xmleditor
									System.out
											.println("success! updating xmleditorpanel");
									jkmt.xmlEditorPanel.xTree
											.refresh(new String(buf));

									jkmt.xmlEditorPanel.xTree.setEnabled(true);
									// all have it. TODO; implement as interface
									jkmt.optionsTab.enableAtConnect();
									jkmt.dpsTab.enableAtConnect();
									jkmt.kmemstatTab.enableAtConnect();
									jkmt.ksymstatTab.enableAtConnect();
									jkmt.ktraqTab.enableAtConnect();
									jkmt.drchkTab.enableAtConnect();

									protocol_state = 2; // state 2, got the
									// banner now

									break; // out of loop
								} else {
									System.out
											.println("was expecting final newline, not: *"
													+ nl + "*");
								}
							} else {
								System.out
										.println("was expecting something else"); // error
							}

							break; // out of this for loop
						}

						// else was expecting other
						break;

					case 2:
						sendFindSysMap(); //TODO: error check these for false.
						protocol_state = 3;
						break;
					
					case 3: // logged in, updated conf, at this point ALERTs and -TOOL_FAILUREs could come in, so must anticipate them while refreshSysmap and kimage here as this is doing!
					case 4:
					case 5:


							if (!notExpected) {
								rr = isr.read(buffer, 0, 4);// "+OK " | "+OK\n"|
								// "ALER" | "-TOO"
								// check if rr == -1, if != that length
								 System.out.println("["+buffer[0] + buffer[1]
								 + buffer[2] + buffer[3] +"]");
							} // else try again with same buffer.

							/*
							 * check the four bytes to categorize the message,
							 * then read the rest
							 */
							if (Net.equalsCharArray(buffer, "ALER"
									.toCharArray(), 4)) /* is an ALERT received? */
							{
								rr = isr.read(buffer, 0, "T ".length()); /*
																		 * yes
																		 * it
																		 * was
																		 */
								if (Net.equalsCharArray(buffer, "T "
										.toCharArray(), 2)) {
									notExpected = false;
									System.out.println("received ALERT\n");
									processAlert(isr);
								} else
									System.out.println("Expected more\n");

							} else if (Net.equalsCharArray(buffer, "-TOO"
									.toCharArray(), 4)) /*
														 * is a -TOOL_FAILURE
														 * received ?
														 */
							{
								rr = isr.read(buffer, 0, "L_FAILURE ".length()); /*
																				 * yes
																				 * it
																				 * was
																				 */
								if (Net.equalsCharArray(buffer, "L_FAILURE "
										.toCharArray(), "L_FAILURE ".length())) {
									notExpected = false;
									System.out
											.println("received -TOOL_FAILURE\n");
									processToolFailure(isr);
								} else
									System.out.println("Expected more\n");

							} else if (protocol_state == 3) {
							    processFindSysMapResp(isr);
							sendFindKernelImage();
							    protocol_state = 4;//not really needed
				 		} else if (protocol_state == 4) {
							    processFindKernelImageResp(isr);
							    protocol_state = 5;
							} else if (expectingExecToolResp != null) {
								    notExpected = false;

								if (buffer[0] == '+' && buffer[1] == 'O'
										&& buffer[2] == 'K' && buffer[3] == ' ') {
									/* RECV RESPONSE AND PARSE */
									// +OK <n> <msg>\n
									n_str = "";
									char cn;

									for (;;) {
										cn = (char) isr.read();

										if ((cn >= '0') && (cn <= '9')) {
											n_str += cn;

											continue; // top of this for loop
										}
										break;
									}

									if (cn != ' ') {
										// error
									}
									System.out.println("n_str = *" + n_str
											+ "*");
									n = Integer.parseInt(n_str);

									// catch throw here
									System.out.println("n = " + n);

									char[] cbuf = new char[n];

									// blocked read of n
									rr = isr.read(cbuf, 0, n);
									System.out.println("rr = " + rr);

									if (rr == -1) {

										// end of stream reached. Not an
										// IOException
									}

									// TODO check n == rr
									char nl = (char) isr.read(); // the final \n
									// ending it

									// if nl == -1
									if (nl == '\n') {
										jkmt.consolePanels.println(expectingExecToolResp, Color.BLACK,
												expectingExecToolResp + ":");
										jkmt.consolePanels.println(expectingExecToolResp, Color.GREEN,
												 new String(cbuf));
										// success
									} // else <n> was wrong

								} else if (buffer[0] == '-' && buffer[1] == 'E'
										&& buffer[2] == 'R' && buffer[3] == 'R') {
									if (isr.read() != ' ') { /* error */
									}

									String resp = "";

									for (;;) {
										char cn = (char) isr.read(); // blocks

										if (cn == '\n') {
											break;
										}
										resp += cn; // \n is not added to string
									}
									System.out.println("err = " + resp);
									JOptionPane.showMessageDialog(jkmt, resp);
								} // else not +OK or -ERR

								/* remove hourglass cursor */
								jkmt
										.setCursor(new Cursor(
												Cursor.DEFAULT_CURSOR));

								expectingExecToolResp = null;// no longer
								// expecting it
							} else if (expectingUpdateResp) {

								notExpected = false;
								String msgstr;
								if (buffer[0] == '+' && buffer[1] == 'O'
										&& buffer[2] == 'K') {
									msgstr = "Successfully Updated Server";
								} else if (buffer[0] == '-' && buffer[1] == 'E'
										&& buffer[2] == 'R' && buffer[3] == 'R') {
									msgstr = "Error updating server. Received -ERR";
								} else
									msgstr = "Error updating server.";

								expectingUpdateResp = false;
								/* remove hourglass cursor */
								jkmt
										.setCursor(new Cursor(
												Cursor.DEFAULT_CURSOR));
								jkmt.consolePanels.printlnJkmt(msgstr);
								JOptionPane.showMessageDialog(jkmt, msgstr);

							} else
								notExpected = true;
						// /* unreachable */ break;
					} // end switch
				} // end infinite loop
		} catch (javax.net.ssl.SSLException ssle) {
			String errstr = "SSL Connection Failed: " + ssle.getMessage();
			jkmt.consolePanels.printlnJkmt(errstr);
			JOptionPane.showMessageDialog(jkmt, errstr);

		} catch (java.net.SocketException ce) {
			String errstr = "Connection to " + host + ":" + port + " failed: "
					+ ce.getMessage();

			jkmt.consolePanels.printlnJkmt(errstr);
			JOptionPane.showMessageDialog(jkmt, errstr);
		} catch (java.io.IOException ioe) {
			ioe.printStackTrace();
		} catch (InterruptedException ignore) {
		}

		// one of the exceptions happened if it got here.
		jkmt.serverTab.cbutton.setText("Connect");
		jkmt.serverTab.cbutton.setActionCommand("connect"); // switch action
		// command
		jkmt.serverTab.hostField.setEnabled(true);
		jkmt.serverTab.portField.setEnabled(true);
		jkmt.serverTab.passwdField.setEnabled(true);
		jkmt.serverTab.sslCheckBox.setEnabled(true);

		return 0;
	}

	// assumes read up to 'ALERT '
	// ALERT <toolname> <N> <multilinedata>\n
	private void processAlert(InputStreamReader isr) {
		_processToolFailureOrAlert(isr, true /* alert */);
	}

	// assumes read up to '-TOOLFAILURE '
	// -TOOL_FAILURE <TOOLNAME> SINGLE <N> <MULTILINE DATA>\n
	private void processToolFailure(InputStreamReader isr) {
		_processToolFailureOrAlert(isr, false /* toolfailure */);
	}

	public boolean sendFindKernelImage() {
	    System.out.println("sendFindKernelImage(),ps="+protocol_state);

		/* SEND REQUEST */
		if (protocol_state < 1) {
			return false;
		}

		try {
			OutputStream os = socket.getOutputStream();
			byte[] buf = ("FIND_KIMAGE\n").getBytes();

			os.write(buf);
		} catch (java.net.SocketException se) {
			JOptionPane.showMessageDialog(jkmt, "Connection reset by peer");
			return false;
		} catch (java.io.IOException ioe) {
			ioe.printStackTrace();
			return false;
		}

		return true;
	}



//read upto the "+OK " before calling
		// resp = "+OK" | "+OK path" | "+OK path,path" |
	public boolean processFindKernelImageResp(InputStreamReader isr) {

	    try {
			/* RECV RESPONSE AND PARSE */
			String resp = "";

			for (;;) {
				char cn = (char) isr.read(); // blocks

				if (cn == '\n') {
					break;
				}

				resp += cn; // \n is not added to string
			}

				String list = resp;

				// System.out.println(list);
				String[] items = list.split(",");

				jkmt.optionsTab.kernelImageList.removeAllItems();

				for (String s : items) {
					jkmt.optionsTab.kernelImageList.addItem(s);
				}
		} catch (java.net.SocketException se) {
			JOptionPane.showMessageDialog(jkmt, "Connection reset by peer");
			return false;
		} catch (java.io.IOException ioe) {
			ioe.printStackTrace();
			return false;
		}

		return true;
	}

	private boolean sendFindSysMap() {
	    System.out.println("sendFindSysMap(),ps="+protocol_state);

		/* SEND REQUEST */
		if (protocol_state < 1) {
			return false;
		}

		try {
			OutputStream os = socket.getOutputStream();
			byte[] buf = ("FIND_SYSMAP\n").getBytes();

			os.write(buf);

} catch (java.net.SocketException se) {
			JOptionPane.showMessageDialog(jkmt, "Connection reset by peer");
			return false;
		} catch (java.io.IOException ioe) {
			ioe.printStackTrace();
			return false;
		}

		return true;
	}

//read upto the "+OK " before calling
			// resp = "+OK" | "+OK path" | "+OK path,path" |
	public boolean processFindSysMapResp(InputStreamReader isr) {

	    System.out.println("processFindSysMapResp()");
		try {
			/* RECV RESPONSE AND PARSE */
			String resp = "";

			for (;;) {
				char cn = (char) isr.read(); // blocks

				if (cn == '\n') {
					break;
				}

				resp += cn; // \n is not added to string
			}

				//String list = resp.substring("+OK ".length());
				String list = resp;

				// System.out.println(list);
				String[] items = list.split(",");

				jkmt.optionsTab.systemMapList.removeAllItems();

				for (String s : items) {
					jkmt.optionsTab.systemMapList.addItem(s);
				}
		} catch (java.net.SocketException se) {
			JOptionPane.showMessageDialog(jkmt, "Connection reset by peer");
			return false;
		} catch (java.io.IOException ioe) {
			ioe.printStackTrace();
			return false;
		}

		return true;
	}

	public boolean sendExecTool(String toolName) {

		/* SEND REQUEST */
		if (protocol_state < 1) {
			return false;
		}

		try {
			/* set hourglass cursor */
			jkmt.setCursor(new Cursor(Cursor.WAIT_CURSOR));
			OutputStream os = socket.getOutputStream();
			byte[] buf = ("EXEC_TOOL " + toolName + "\n").getBytes();

			os.write(buf);
			expectingExecToolResp = toolName;// changed to toolName from null
			return true;

		} catch (java.net.SocketException se) {
			/* remove hourglass cursor */
			jkmt.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
			JOptionPane.showMessageDialog(jkmt, "Connection reset by peer");
			return false;
		} catch (java.io.IOException ioe) {
			ioe.printStackTrace();
			// TODO: put Jpoppup
			return false;
		}

	}

	public boolean sendUpdate(String xmlText) {
		/* set hourglass cursor */
		jkmt.setCursor(new Cursor(Cursor.WAIT_CURSOR));

		try {
			OutputStream os = socket.getOutputStream();
			byte[] buf = ("UPDATE_CONF " + xmlText.length() + ' ' + xmlText + '\n')
					.getBytes();

			os.write(buf);
		} catch (java.net.SocketException se) {
			/* remove hourglass cursor */
			jkmt.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
			JOptionPane.showMessageDialog(jkmt, "Connection reset by peer");
			return false;
		} catch (java.io.IOException ioe) {
			ioe.printStackTrace();
			/* remove hourglass cursor */
			jkmt.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
			return false;
		}

		this.expectingUpdateResp = true;
		return true;
	}

}
	
