#include "kmond.h"

int GetPid(char *path)
{
	FILE *pd;
	char *p, cmd[255], buf[255]; 
	int pid, i = 0;
	char val[16];

	snprintf(cmd, sizeof(cmd)-1, "ps xw | grep %s", path);
	
	if ((pd = popen(cmd, "r")) == NULL)
	{
		KMTLog_err("Fatal error (Try restarting kmond) GetPid() failed with popen(): %s\n", strerror(errno));
		return -1;
	}
	
	while (fgets(buf, sizeof(buf), pd))
	{
		if (strstr(buf, path))	
		{
			/* We don't care about the grep itself */
			if (strstr(buf, "grep"))
				continue;
			// looking for a line like this:
			// 9961 ?        Rs     0:16 /opt/kmt/sbin/kmtd -c ../kmtd/kmt.conf

			/* Never can be too sure that atoi */
			/* will stop processing at white spaces */
			/* So lets create a string called val */	
			p = buf;
			while (*p == 0x20)
				p++;
			while (*p >= '0' && *p <= '9')
				val[i++] = *(p++);
			val[i] = '\0';
			pid = atoi(val);
			/* Something went wrong */	
			if (pid == 0)
				return -1;
			/* Yay found process ID of kmtd */	
			return pid;
		}
	}
	/* Should only get here if PID isn't found */
	return 0;
}
