#include "kmtd.h"

#define DELIM " "
#define LB "127.0.0.1"

/* This ugly ass function was taken straight from abyss */
/* (which is of course, ugly ass code) */
/* This gets the first local IP that is not the loop back */
/* This can be modified */
uint32_t get_local_ip (void)
{
	int i;
  	FILE *pf;
  	char *p;
 	char line[100];
	uint32_t local_ipaddr;

	if ((pf = popen ("/sbin/ifconfig", "r")) == NULL)
		if ((pf = popen("/usr/sbin/ifconfig", "r")) == NULL)
			return 0;

  	/* search through ifconfig strings for parsing */
  	while (fgets (line, sizeof (line), pf) != NULL)
    	{
      		/* In reguards to Linux */
      	if (strstr (line, "inet addr"))
        {
        	p = strtok (line, ":");
          	p = strtok (NULL, DELIM);
          	if (strstr (p, LB))
            		continue;
         	else 
		if ((local_ipaddr = inet_addr (p)) != -1)
            	{
              		pclose (pf);
              		return local_ipaddr;
            	}
        }
      	else
        /* In reguards to BSD */
        if (strstr (line, "inet") && !strstr (line, "addr") &&
           !strstr (line, "inet6"))
        {

        	p = strtok (line, DELIM);
          	p = strtok (NULL, DELIM);
          	if (strstr (p, LB))
            		continue;
          	else 
		if ((local_ipaddr = inet_addr (p)) != -1)
            	{
              		pclose (pf);
              		return local_ipaddr;
            	}
        }
    }
  pclose (pf);
}

void exec_string (char *str, ...)
{
        char string[255];
        va_list va;

        va_start (va, str);
        vsnprintf (string, 255, str, va);
        va_end (va);

        system (string);
}

void set_host_values(void)
{
	struct utsname uts;
	extern uint32_t host_ip;
	extern char host_OS[255];
	extern char hostname[255];
	extern struct opts opts;
	char ipbuf[20];

	host_ip = get_local_ip();
	
	uname(&uts);
	snprintf(host_OS, sizeof(host_OS), "%s %s", uts.sysname, uts.release);
	snprintf(hostname, sizeof(hostname), "%s", uts.nodename);
	
	/* No more inet_ntoa() */
	inet_ntop(AF_INET, &host_ip, ipbuf, INET_ADDRSTRLEN);

	if (opts.debug)
		printf("[+] IP -> \t%s\n[+] OS ->\t%s\n[+] Host ->\t%s\n",ipbuf, host_OS, hostname);
}
	
/* THIS function is deprecated ( was never done anyway) */
int locate_system_map(char *conf_path)
{
	char buf[512];
	int len, c, i, j;
	FILE *fd;
	char *p, *s, line[512], tmp[255];
	long offset[512];

	//len = get_sysmap_path(buf);
	if (len < 0)
		return -1;
		
	if ((fd = fopen(conf_path, "r+")) == NULL)
		return -1;
	
	for (i = 0; fgets(line, sizeof(line), fd) != NULL; i++)
	{
		s = line;
		for (c = 0; *s == 0x20; c++)
			s++;
		offset[i] = ftell(fd);

		if (strncasecmp(s, "<system_map>", 12) == 0)
		{
			for (j = 0, p = s; *p != '\n'; p++)
				j++;

			offset[i - 1] += c;
			fseek(fd, offset[i - 1], SEEK_SET);
			
			while (j-- > 0)
				fputc(0x20, fd);

			fseek(fd, offset[i - 1], SEEK_SET);
			fprintf(fd, "<system_map>%s</system_map>\n", buf);
			fflush(fd);
			return 0;
		}
	}

	/* If we're still here we did not find the existing entry */
	//fseek(fd, SEEK_END, 0);
	//fprintf(fd, "<system_map>%s</system_map>", buf);
	
	return 0;
}
	
int compress(char *passwd, char *zip_file)
{
	FILE *pd;
	char buf[255];
	char cmd[1024];
	char time_buf[255];
        time_t clock;
        struct tm *tm;
	extern struct opts opts;
	struct stat st;
	if ((pd = popen("ls /var/log/kmt/*.log", "r")) == NULL)
	{
		KMTLog_err("Unable to locate System.map file");
		return -1;
	}

	/* Make sure directory exists. Otherwise a hacker can simply */
	/* Remove this directory, and prevent admins from getting the logs */
	/* via Email. (NOT GOOD) */
	if (stat("/var/log/kmt/.zip", &st) < 0)
	{
		switch(errno)
		{
			case ENOTDIR:
				/* This assumes its a file and not a dir */
				unlink("/var/log/kmt/.zip");
				mkdir("/var/log/kmt/.zip", 0770);
				break;
			case ENOENT:
				mkdir("/var/log/kmt/.zip", 0770);
				break;
			default:
				KMTLog_err("Error accessing /var/log/kmt/.zip directory\n");
				return -1;
				
		}
	}
			
	time (&clock);
        tm = gmtime (&clock);
        setlocale (LC_TIME, "C");
        strftime (time_buf, sizeof (time_buf), "%A_%B_%e_%Y", tm);

	snprintf(cmd, 1024/2, "%s %s /var/log/kmt/.zip/kmt_%s.zip", ZIP, passwd, time_buf);
	
	snprintf(zip_file, 254, "/var/log/kmt/.zip/kmt_%s.zip", time_buf);

	while(fgets(buf, sizeof(buf), pd))
	{
		/* Remove definite newline */
		buf[strlen(buf) - 1] = '\0';

		if (strstr(buf, "kmtd.log"))
			sprintf(&cmd[strlen(cmd)], " %s", buf);
		else
		if (strstr(buf, "kmemstat.log"))
			sprintf(&cmd[strlen(cmd)], " %s", buf);
                else
		if (strstr(buf, "ksymstat.log"))
                        sprintf(&cmd[strlen(cmd)], " %s", buf);
                else
                if (strstr(buf, "ktraq.log"))
			sprintf(&cmd[strlen(cmd)], " %s", buf);
		else
		if (strstr(buf, "dps.log"))
                        sprintf(&cmd[strlen(cmd)], " %s", buf);

	}
	
	if (opts.debug)
		printf("[+] compress(): Command -> %s\n", cmd);
	
	int ret = system(cmd);
        if (ret == 127 || ret == -1)
        	return -1;
	pclose(pd);
	
	return 0;
}
