#include "patch_kmem.h"

unsigned long get_capable(void)
{
	FILE *fd;
	int i;
	unsigned long address;
	char tmp[255];

	if ((fd = fopen("/proc/kallsyms", "r")) == NULL)
	{
		perror("Unable to open /proc/kallsyms");
		return -1;
	}
	
	for (; !feof(fd); )
        { 
                bzero(symbol_s, BUFSZ);  
                /* get symbol address for symbol we want */
                fscanf(fd, "%x %c %s", &address, &type, &symbol_s);
                if (strcmp(symbol_s, "capable") == 0)
                {
                        fscanf(fd, "%x %c %s", &next_symaddr, &tmp_type, &tmp); 
                        fclose(fd);
                        return address;

                } 
                /* kallsyms isn't a regular file, meaning there is no EOF */
                if (!strcmp(symbol_s, ""))
                        break;
	}
	return 0;
}



	
