//~--- JDK imports ------------------------------------------------------------

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;

public class UpdateServerPanel extends JPanel implements ActionListener {

	public static void enableAllUsp() {
		Jkmt jkmt = Jkmt.getInstance();
		jkmt.optionsTab.usp.updateButton.setEnabled(true);
		jkmt.dpsTab.usp.updateButton.setEnabled(true);
		jkmt.kmemstatTab.usp.updateButton.setEnabled(true);
		jkmt.ksymstatTab.usp.updateButton.setEnabled(true);
		jkmt.ktraqTab.usp.updateButton.setEnabled(true);
		jkmt.drchkTab.usp.updateButton.setEnabled(true);

	}

	Jkmt jkmt = Jkmt.getInstance();

	JButton updateButton = null;

	public UpdateServerPanel() {
		super();

		this.updateButton = new JButton("Update Server");
		updateButton.setActionCommand("updateserver");
		updateButton.setEnabled(false);
		updateButton.addActionListener(this);

		setLayout(new FlowLayout(FlowLayout.LEADING));

		JLabel l = new JLabel(
				"<html>"
						+ "<p><font size=\"2\">Changing any of these options will update the local XML document.</font></p>"
						+ "<p><font size=\"2\">It must still be saved to server.</font></p>"
						+ "</html>");

		add(l);
		add(updateButton);
	}

	public void actionPerformed(ActionEvent ae) {
		String actionCommand = ae.getActionCommand();

		if (ae.getActionCommand().equals("updateserver")) {
			try {
String xmlStr = jkmt.xmlEditorPanel.xTree.generateXml();
				boolean res = jkmt.net.sendUpdate(xmlStr);
				if (res) {
					String str = "Sent update to server.";
					jkmt.consolePanels.printlnJkmt(str);

					jkmt.optionsTab.usp.updateButton.setEnabled(false);
					jkmt.dpsTab.usp.updateButton.setEnabled(false);
					jkmt.kmemstatTab.usp.updateButton.setEnabled(false);
					jkmt.ksymstatTab.usp.updateButton.setEnabled(false);
					jkmt.ktraqTab.usp.updateButton.setEnabled(false);
					jkmt.drchkTab.usp.updateButton.setEnabled(false);
				} else {
					String str = "Failed to Update Server.";
					jkmt.consolePanels.printlnJkmt(str);
					JOptionPane.showMessageDialog(jkmt, str);

					// TODO: popup error that network or something failed.
				}

			} catch (Exception ex) {
				String message = ex.getMessage();

				ex.printStackTrace();
			}
		}
	}

	public void disableAll() {
		updateButton.setEnabled(false);
	}

	public void enableAtConnect() {
		/*
		 * not until modified
		 */
	}

}
